﻿using Mediachase.Commerce.Engine;
using Mediachase.Commerce.Orders.Managers;
using Mediachase.Commerce.Workflow.Activities;
using Mediachase.Commerce.Workflow.Activities.Cart;
using Mediachase.Commerce.Workflow.Activities.PurchaseOrderActivities;
using System;

namespace Mediachase.Commerce.Workflow
{
    /// <summary>
    /// This class represents the Cart Validate workflow
    /// </summary>
    [ActivityFlowConfiguration(Name = OrderGroupWorkflowManager.CartValidateWorkflowName, LegacyMode = true)]
    [Obsolete("This ActivityFlow uses activities which are obsoleted. We recommend to use new ActivityFlows. Will be removed August 2018.")]
    public class LegacyCartValidateActivityFlow : ActivityFlow
    {
        /// <inheritdoc />
        public override ActivityFlowRunner Configure(ActivityFlowRunner activityFlow)
        {
            return
                activityFlow
                    .Do<ValidateLineItemsActivity>()
                    .Do<GetFulfillmentWarehouseActivity>()
                    .If(ShouldCheckInstoreInventory)
                        .Do<CheckInstoreInventoryActivity>()
                    .Else()
                        .Do<CheckInventoryActivity>()
                    .EndIf()
                    .Do<CalculateTotalsActivity>()
                    .Do<LegacyRemoveDiscountsActivity>()
                    .Do<CalculateTotalsActivity>()
                    .Do<LegacyCalculateDiscountsActivity>()
                    .Do<CalculateTotalsActivity>()
                    .Do<RecordPromotionUsageActivity>();
        }
    }
}
