﻿using Mediachase.Commerce.Engine;
using Mediachase.Commerce.Orders.Managers;
using Mediachase.Commerce.Workflow.Activities;
using Mediachase.Commerce.Workflow.Activities.Cart;
using System;

namespace Mediachase.Commerce.Workflow
{
    /// <summary>
    /// This class represents the Purchase Order Calculate Totals workflow
    /// </summary>
    [ActivityFlowConfiguration(Name = OrderGroupWorkflowManager.OrderCalculateTotalsWorkflowName, LegacyMode = true)]
    [Obsolete("This ActivityFlow uses activities which are obsoleted. We recommend to use new ActivityFlows. Will be removed August 2018.")]
    public class LegacyPOCalculateTotalsActivityFlow : ActivityFlow
    {
        /// <inheritdoc />
        public override ActivityFlowRunner Configure(ActivityFlowRunner activityFlow)
        {
            return
                activityFlow
                    .Do<ProcessShipmentsActivity>()
                    .Do<CalculateTotalsActivity>()
                    .Do<LegacyRemoveDiscountsActivity>()
                    .Do<CalculateTotalsActivity>()
                    .Do<LegacyCalculateDiscountsActivity>()
                    .Do<CalculateTotalsActivity>()
                    .Do<CalculateTaxActivity>()
                    .Do<CalculateTotalsActivity>()
                    .Do<RecordPromotionUsageActivity>();
        }
    }
}
