﻿using Mediachase.Commerce.Engine;
using Mediachase.Commerce.Orders.Managers;
using Mediachase.Commerce.Workflow.Activities;
using Mediachase.Commerce.Workflow.Activities.Cart;
using Mediachase.Commerce.Workflow.Activities.PurchaseOrderActivities;
using System;

namespace Mediachase.Commerce.Workflow
{
    /// <summary>
    /// This class represents the Purchase Order Recalculate workflow
    /// </summary>
    [ActivityFlowConfiguration(Name = OrderGroupWorkflowManager.OrderRecalculateWorkflowName, LegacyMode = true)]
    [Obsolete("This ActivityFlow uses activities which are obsoleted. We recommend to use new ActivityFlows. Will be removed August 2018.")]
    public class LegacyPORecalculateActivityFlow : ActivityFlow
    {
        /// <inheritdoc />
        public override ActivityFlowRunner Configure(ActivityFlowRunner activityFlow)
        {
            return
                activityFlow
                    .Do<ValidateLineItemsActivity>()
                    .Do<GetFulfillmentWarehouseActivity>()
                    .If(ShouldAdjustInventory)
                        .If(ShouldCheckInstoreInventory)
                            .Do<CheckInstoreInventoryActivity>()
                        .Else()
                            .Do<CheckInventoryActivity>()
                        .EndIf()
                    .EndIf()
                    .If(ShouldAdjustInventory)
                        .Do<AdjustInventoryActivity>()
                    .EndIf()
                    .If(ShouldRecalculateOrder)
                        .Do<ProcessShipmentsActivity>()
                        .Do<LegacyRemoveDiscountsActivity>()
                        .Do<CalculateTotalsActivity>()
                        .Do<LegacyCalculateDiscountsActivity>()
                        .Do<CalculateTotalsActivity>()
                        .Do<CalculateTaxActivity>()
                        .Do<CalculateTotalsActivity>()
                    .EndIf()
                    .Do<CalculatePurchaseOrderStatusActivity>();
        }
    }
}
