﻿using Mediachase.Commerce.Engine;
using Mediachase.Commerce.Orders.Managers;
using Mediachase.Commerce.Workflow.Activities;
using Mediachase.Commerce.Workflow.Activities.OrderGroupActivities;

namespace Mediachase.Commerce.Workflow
{
    /// <summary>
    /// Activity flow that is used to update all the discounts for an order.
    /// </summary>
    [ActivityFlowConfiguration(Name = OrderGroupWorkflowManager.OrderCalculateTotalsWorkflowName)]
    public class POCalculateTotalsActivityFlow : ActivityFlow
    {
        /// <inheritdoc />
        public override ActivityFlowRunner Configure(ActivityFlowRunner activityFlow)
        {
            return
                activityFlow
                    .Do<RemoveDiscountsActivity>()
                    .Do<CalculateDiscountsActivity>()
                    .Do<UpdateTotalsActivity>();
        }
    }
}
