﻿using System;
using System.Configuration;
using System.Data;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Threading;
using Mediachase.Commerce;
using Mediachase.Commerce.Customers.Profile;

namespace Mediachase.Commerce.Website.BaseControls
{
    [Obsolete("This class is no longer used. Will remain at least until July 2018.")]
    public partial class StaticBasePage : Page
    {
        #region Render
        /// <summary>
        /// We override Render to swap out the default HtmlTextWriter for our own. Our own Writer's sole purpose is to
        /// change the the action attribute on the form tag to the vanity Url. This way all postbacks occur on the vanity url
        /// </summary>
        /// <param name="writer">The <see cref="T:System.Web.UI.HtmlTextWriter"></see> that receives the page content.</param>
        protected override void Render(HtmlTextWriter writer)
        {
            HtmlMeta generatorMeta = new HtmlMeta();
            generatorMeta.Name = "GENERATOR";
            generatorMeta.Content = FrameworkContext.ProductName;
            this.Header.Controls.Add(generatorMeta);

            HtmlMeta versionMeta = new HtmlMeta();
            versionMeta.Name = "VERSION";
            versionMeta.Content = FrameworkContext.ProductVersionDesc;
            this.Header.Controls.Add(versionMeta);

            //if (CmsContext.Current.IsUrlReWritten)
            {
                if (writer is System.Web.UI.Html32TextWriter)
                {
                    writer = new FormFixerHtml32TextWriter(writer.InnerWriter);
                }
                else
                {
                    writer = new FormFixerHtmlTextWriter(writer.InnerWriter);
                }
            }

            base.Render(writer);

            /*
            StringWriter sw = new StringWriter();
            HtmlTextWriter hw = new HtmlTextWriter(sw);
            base.Render(hw);
            string html = sw.ToString();

            // Hose the writers we don't need anymore.
            hw.Close();
            sw.Close();

            int start = html.IndexOf("<input type=\"hidden\" name=\"__VIEWSTATE\"");
            // If we find it, then move it.
            if (start > -1)
            {
                int end = html.IndexOf("/>", start) + 2;

                // Strip out the viewstate.
                string viewstate = html.Substring(start, end - start);
                html = html.Remove(start, end - start);

                // Find the end of the form and insert it there, since we can't put it any lower in the response stream.
                int formend = html.IndexOf("</form>");
                html = html.Insert(formend, viewstate);
            }

            // Send the results back into the writer provided.
            writer.Write(html);
             * */
        }
        #endregion

        #region FormFixers

        #region FormFixerHtml32TextWriter
        internal class FormFixerHtml32TextWriter : System.Web.UI.Html32TextWriter
        {
            private string _url;

            /// <summary>
            /// Initializes a new instance of the <see cref="FormFixerHtml32TextWriter"/> class.
            /// </summary>
            /// <param name="writer">The writer.</param>
            internal FormFixerHtml32TextWriter(TextWriter writer)
                : base(writer)
            {
                _url = HttpContext.Current.Request.RawUrl;
            }

            /// <summary>
            /// Writes the attribute.
            /// </summary>
            /// <param name="name">The name.</param>
            /// <param name="value">The value.</param>
            /// <param name="encode">if set to <c>true</c> [encode].</param>
            public override void WriteAttribute(string name, string value, bool encode)
            {
                if (_url != null && string.Compare(name, "action", true) == 0)
                {
                    value = _url;
                }
                base.WriteAttribute(name, value, encode);
            }
        }
        #endregion

        #region FormFixerHtmlTextWriter
        internal class FormFixerHtmlTextWriter : System.Web.UI.HtmlTextWriter
        {
            private string _url;
            /// <summary>
            /// Initializes a new instance of the <see cref="FormFixerHtmlTextWriter"/> class.
            /// </summary>
            /// <param name="writer">The writer.</param>
            internal FormFixerHtmlTextWriter(TextWriter writer)
                : base(writer)
            {

                _url = HttpContext.Current.Request.RawUrl;
            }

            /// <summary>
            /// Writes the attribute.
            /// </summary>
            /// <param name="name">The name.</param>
            /// <param name="value">The value.</param>
            /// <param name="encode">if set to <c>true</c> [encode].</param>
            public override void WriteAttribute(string name, string value, bool encode)
            {
                if (_url != null && string.Compare(name, "action", true) == 0)
                {
                    value = _url;
                }

                base.WriteAttribute(name, value, encode);
            }
        }
        #endregion

        #endregion
    }
}
